/*
 * Created on Nov 1, 2004
 * Copyright (C) Andrea Schweer, 2004
 *
 * This file is part of the Greenstone Alerting Service.
 * Refer to the COPYING file in the base directory of this package
 * for licensing information.
 */
package org.greenstone.gsdlas.profiles;

import java.util.*;
import java.util.Set;
import java.util.TreeSet;

/**
 * @author schweer
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class QueryPredicate extends Predicate {
    
    private Set containsWords = new TreeSet();
    private Set notContainsWords = new TreeSet();
    
    public QueryPredicate (String field, String query) {
        super.field = field;
        super.value = query;
        
        String[] words = query.split("\\s");
        for (int i = 0; i < words.length; i++) {
            String word = words[i];
            if (!word.startsWith("!")) {
                containsWords.add(word);
            } else {
                if (word.length() > 1) {
                    notContainsWords.add(word);
                } else if (i < words.length - 1) {
                    notContainsWords.add(words[i++]);
                }
            }
        }
    }

    /* (non-Javadoc)
     * @see org.greenstone.gsdlas.profiles.Predicate#isSatisfied(java.util.Map)
     */
    public boolean isSatisfied(Map event) {
        // TODO more efficient implementation
        
        String value = (String) event.get(field);
        if (value == null) return false;
        
        
        for (Iterator iter = containsWords.iterator(); iter.hasNext();) {
            String word = (String) iter.next();
            if (value.indexOf(word) == -1) {
                return false;
            }
        }
        
        for (Iterator iter = notContainsWords.iterator(); iter.hasNext();) {
            String word = (String) iter.next();
            if (value.indexOf(word) >= 0) {
                return false;
            }
        }
        
        return true;
    }
}