/*
 * Created on Nov 18, 2004
 * Copyright (C) Andrea Schweer, 2004
 *
 * This file is part of the Greenstone Alerting Service.
 * Refer to the COPYING file in the base directory of this package
 * for licensing information.
 */
package org.greenstone.gsdlas;

import java.net.URL;
import java.util.*;

import junit.framework.TestCase;

import org.greenstone.gsdlas.profiles.*;

/**
 * @author schweer
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ProfileStoreTest extends TestCase {

    public static void main(String[] args) {
        junit.textui.TestRunner.run(ProfileStoreTest.class);
    }

    public final void testAddSubscription() {
        try {
            addSubscriptions();
        } catch (ParseException e) {
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

    public final void testFilter() {
        try {
            addSubscriptions();
            
            URL url = new URL("http://localhost:8080/soap/servlet/rpcrouter");
            GreenstoneCommunicator gsComm = new GreenstoneCommunicator(url);
            
            Map event = new TreeMap();
            
            event.put("documentID", "20041118:5");
            event.put("collectionID", "gs3mgdemo");
            event.put("host", "http://localhost:8080/soap/servlet/rpcrouter");
            
            Set result = ProfileStore.getInstance().filter(event, gsComm);
            
            System.out.println(result.size());
            
        } catch (Exception e) {
            e.printStackTrace();
            fail(e.getMessage());
        }
    }

    private void addSubscriptions() throws ParseException {
        Map valueMap = new TreeMap();
        
        valueMap.put("collectionID", "gs3mgdemo");
        valueMap.put("document_content", "Tomatensalat");
        
        addSubscription(valueMap);
        
        valueMap.clear();
        
        valueMap.put("collectionID", "gs3mgdemo");
        valueMap.put("document_content", "Water+Buffalo");
        
        addSubscription(valueMap);
        
        valueMap.clear();
        
        valueMap.put("collectionID", "gs3mgdemo");
        valueMap.put("document_content", "gender+equality");
        
        addSubscription(valueMap);
    }
    
    private void addSubscription(Map valueMap) throws ParseException {    
        Subscription sub = new Subscription(valueMap);
        // TODO this should probably be somewhere else
        for (Iterator iter = sub.predicates().iterator(); iter.hasNext();) {
            Predicate predicate = (Predicate) iter.next();
            if (predicate != null) {
                predicate.addSubscription(sub);
            }
        }
        ProfileStore.getInstance().addSubscription(sub);    
    }
    
}
